;Logo.asm
;by Dan Goodberry

#include "asm86.h"
#include "ti86asm.inc"

.org _asm_exec_ram
	nop
	jp Start
.dw $0000
.dw Title
Title:
	.db "Startup Logo",0

Start:
	call    _runindicoff
	ld      a, $01
	out     ($03), a
	HALT
	ld      a, $0b
	out     ($03), a	;end shutoff routine

	call _clrLCD

	ld hl,$fc00
	ld de,Logo
	call Loop
	ld hl,$fc10
	ld de,Logo
	call Loop
	ld hl,$fc20
	ld de,Logo
	call Loop
	ld hl,$fc30
	ld de,Logo
	call Loop
	ld hl,$fc40
	ld de,Logo
	call Loop
	ld hl,$fc50
	ld de,Logo
	call Loop
	ld hl,$fc60
	ld de,Logo
	call Loop
	ld hl,$fc70
	ld de,Logo
	call Loop
	ld hl,$fc80
	ld de,Logo
	call Loop
	ld hl,$fc90
	ld de,Logo
	call Loop
	ld hl,$fca0
	ld de,Logo
	call Loop
	ld hl,$fcb0
	ld de,Logo
	call Loop
	ld hl,$fcc0
	ld de,Logo
	call Loop
	ld hl,$fcd0
	ld de,Logo
	call Loop
	ld hl,$fce0
	ld de,Logo
	call Loop
	ld hl,$fcf0
	ld de,Logo
	call Loop
	ld hl,$fd00
	ld de,Logo
	call Loop
	ld hl,$fd10
	ld de,Logo
	call Loop
	ld hl,$fd20
	ld de,Logo
	call Loop
	ld hl,$fd30
	ld de,Logo
	call Loop
	ld hl,$fd40
	ld de,Logo
	call Loop

	res   4,(iy+$09)	;no error on startup (from On key flag)
	ret			;quit

;******************************************************

Loop:
	ld b,17
Loop2:
	push bc
	ld b,16
Draw:
	ld a,(de)		;Get sprite data
	ld (hl),a		;Put sprite data
	inc de			;Next bit of sprite
	inc hl			;Next bit on screen
	dec b			;--- Loop while b > 0 ---
	jr nz,Draw		;Repeat the Loop
	pop bc
	dec b
	jr nz,Loop2
	ld b,$a5		;lower # is faster
Wait:
	push bc
	ld b,$ff
Wait2:
	dec b
	jr nz, Wait2
	pop bc
	dec b
	jr nz, Wait

	ret

Logo:

.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 0,$f0,$3c,$f0,$00,$00,$00,$00,$00,$00,$03,$c0,$00,%00111100,0,0
.db 0,$f0,$3c,$f0,$00,$00,$00,$00,$00,$00,$03,$c0,$00,%01000010,0,0
.db 0,$fc,$3c,$f0,$00,$0f,$00,$00,$00,$00,$03,$c0,$00,%10111001,0,0
.db 0,$fc,$3c,$f0,$00,$0f,$00,$00,$00,$00,$03,$c0,$00,%10100101,0,0
.db 0,$fc,$3c,$00,$00,$3f,$c0,$00,$00,$00,$03,$c0,$00,%10111001,0,0
.db 0,$fc,$3c,$00,$00,$3f,$c0,$00,$00,$00,$03,$c0,$00,%10100101,0,0
.db 0,$f3,$3c,$f3,$cf,$0f,$0f,$f0,$f3,$c0,$ff,$c3,$fc,%01000010,0,0
.db 0,$f3,$3c,$f3,$cf,$0f,$0f,$f0,$f3,$c0,$ff,$c3,$fc,%00111100,0,0
.db 0,$f3,$3c,$f3,$f3,$cf,$3c,$3c,$fc,$f3,$c3,$cf,$0f,0,0,0
.db 0,$f3,$3c,$f3,$f3,$cf,$3c,$3c,$fc,$f3,$c3,$cf,$0f,0,0,0
.db 0,$f0,$fc,$f3,$c3,$cf,$3f,$fc,$f0,$f3,$c3,$cf,$0f,0,0,0
.db 0,$f0,$fc,$f3,$c3,$cf,$3f,$fc,$f0,$f3,$c3,$cf,$0f,0,0,0
.db 0,$f0,$fc,$f3,$c3,$cf,$3c,$00,$f0,$f3,$c3,$cf,$0f,0,0,0
.db 0,$f0,$fc,$f3,$c3,$cf,$3c,$00,$f0,$f3,$c3,$cf,$0f,0,0,0
.db 0,$f0,$3c,$f3,$c3,$cf,$0f,$fc,$f0,$f0,$ff,$c3,$fc,0,0,0
.db 0,$f0,$3c,$f3,$c3,$cf,$0f,$fc,$f0,$f0,$ff,$c3,$fc,0,0,0

.end
end
